/*
*******************************************************************************
**
**  This device driver was created by Applilet for the 78K0S/KB1+, 78K0S/KA1+,
**  78K0S/KY1+ 8-Bit Single-Chip Microcontrollers.
**
**  Copyright(C) NEC Electronics Corporation 2002-2006
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	main.c
**  Abstract :	This file implements main function.
**  APIlib :	NEC78K0SKX1+.lib E1.46h [16 Feb. 2006]
**
**  Device :	uPD78F9222
**
**  Compiler :	NEC/CC78K0
**
*******************************************************************************
*/
/*
*******************************************************************************
**  Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "system.h"
#include "port.h"
#include "watchdogtimer.h"
#include "serial.h"
/*
*******************************************************************************
**  MacroDefine
*******************************************************************************
*/
/*
**---------------------------------------------------------------------------
**
**  Abstract:
**	This function implements main function.
**
**  Parameters:
**	None
**
**  Returns:
**	None
**
**---------------------------------------------------------------------------
*/
/* vg^Cv錾 */

void lcd_write(unsigned char c);
void lcd_clear(void);
void lcd_puts(const char * s);
void lcd_putc(char c);
void lcd_goto(unsigned char pos);
void lcd_init(void);
void Delay40u(void) ;
void Delay2Ms(void);
void Delay2msXn(unsigned int cnt);

/* LCD[qzu */
#define LCD_RS		P4.1
#define LCD_E		P4.2
/* #define  LCD_Data	P2.0-P2.3 = DB4-DB7 */
#define	LCD_STROBE	((LCD_E = 1),(LCD_E=0))


/* 40uS҂ */
void Delay40u(void)
{
	 unsigned char i  ;
	i = 9 ;
	while (i--);
}


/* 2mS҂֐ */
void Delay2Ms(void)
{
	unsigned long i;
	i = 118 ;
	while (i--);
}

/* 2ms X N҂֐ */
void Delay2msXn(unsigned int cnt)
{
	unsigned int i;
	for (i=0;i<cnt;i++)
		Delay2Ms();	/* 2mS҂[vJEg*/
}

/* 4rbg[hLCDɏ */
void lcd_write(unsigned char c)
{
	P2=c >> 4;
	LCD_STROBE;
	P2=c & 0x0F;
	LCD_STROBE;
	Delay40u();
}

/* \NA */
void lcd_clear(void)
{
	LCD_RS=0;
	lcd_write(0x1);
	Delay2Ms();
}

/* XgOLCD\ */
void lcd_puts(const char * s)
{
	LCD_RS=1;	/* write characters */
	while(*s)
		lcd_write(*s++);
}

/* PLN^LCD\ */
void lcd_putc(char c)
{
	LCD_RS=1;	/* write characters */
	P2=c >> 4 ;
	LCD_STROBE;
	P2=c & 0x0F;
	LCD_STROBE;
	Delay40u();
}

/* \ʒuw */
void lcd_goto(unsigned char pos)
{
	LCD_RS=0;	/* write control bytes */
	lcd_write(0x80+pos);
}

/* LCD */
void lcd_init(void)
{
	LCD_RS=0;	/* write control bytes */
	Delay2msXn(20);	/* power on delay 40mS */
	P2=3;		/* attention! */
	LCD_STROBE;
	Delay2msXn(3);
	LCD_STROBE;
	Delay2Ms();
	LCD_STROBE;
	Delay2msXn(3);
	P2=2;		/* set 4 bit mode */
	LCD_STROBE;
	Delay40u();
	lcd_write(0x28);	/* 4 bit mode, 1/16 duty, 5x8 font */
	lcd_write(0x08);	/* display off */
	lcd_write(0x0F);	/* display on, blink curson on */
	lcd_write(0x06);	/* entry mode */
}
unsigned char lastROW ;
void main( void )
{
	/* TODO. add user code */
	/*@̎_UART͂łɏ */
	lcd_init();			/* LCD*/
	lcd_puts("LCD DEMO");
	lastROW = 1 ;
	lcd_goto(0x40) ;
	while(1){
		;
	}
}

