/*
*******************************************************************************
**
**  This device driver was created by Applilet for the 78K0S/KB1+, 78K0S/KA1+,
**  78K0S/KY1+ 8-Bit Single-Chip Microcontrollers.
**
**  Copyright(C) NEC Electronics Corporation 2002-2006
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	serial.h
**  Abstract :	This file implements device driver for serial module.
**  APIlib :	NEC78K0SKX1+.lib E1.46h [16 Feb. 2006]
**
**  Device :	uPD78F9222
**
**  Compiler :	NEC/CC78K0
**
*******************************************************************************
*/
#ifndef _MDSERIAL_
#define _MDSERIAL_

#define UART_ERR_PARITY		0x04		/* UART parity error */
#define UART_ERR_FRAME		0x02		/* UART frame error */
#define UART_ERR_OVERRUN	0x01		/* UART overrun error */
/*
*******************************************************************************
**  Global variables
*******************************************************************************
*/
#define	UART_BAUDRATE_M6	0x1
#define	UART_BAUDRATE_K6	0xd0

void UART6_Init( void );
MD_STATUS UART6_ReceiveData( UCHAR* rxbuf, UCHAR rxnum );
__interrupt void MD_INTSR6( void );

#endif
