/*
*******************************************************************************
**
**  This device driver was created by Applilet for the 78K0S/KB1+, 78K0S/KA1+,
**  78K0S/KY1+ 8-Bit Single-Chip Microcontrollers.
**
**  Copyright(C) NEC Electronics Corporation 2002-2006
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	serial_user.c
**  Abstract :	This file implements device driver for serial module.
**  APIlib :	NEC78K0SKX1+.lib E1.46h [16 Feb. 2006]
**
**  Device :	uPD78F9222
**
**  Compiler :	NEC/CC78K0
**
*******************************************************************************
*/
/*
*******************************************************************************
**  Include files
*******************************************************************************
*/

#pragma	interrupt	INTSR6	MD_INTSR6

#include "macrodriver.h"
#include "serial.h"

extern unsigned char lastROW ;
__interrupt void MD_INTSR6( void )
{
	UCHAR err_type;
	UCHAR tmp;

	err_type = ASIS6;
	tmp = RXB6;

	if( err_type & 0x07 ){			/* status check */
		return;
	}
	if ( tmp == '\r') 
	     {
		if (lastROW) 
			lastROW = 0;
		else
			lastROW = 1;
		tmp=0x40*lastROW+0x80 ;
		P4.1 = 0 ; /* RS=0 Command */
	     }
	else
	    P4.1 = 1;	/*RS=1 Dtata */

	/*EFCƖLCD֏o͂*/	
	P2=tmp >> 4;
	P4.2 = 1 ;	/* E=ON LCD_STROBE */
	P4.2 = 0 ;
	P2=tmp & 0x0F;
	P4.2 = 1 ;	/* E=ON LCD_STROBE */
	P4.2 = 0 ;
	
}

